#ifndef FILTER_H
#define FILTER_H

#include <QStringList>
#define ICON_PATH QString("/runtime/elettra/share/icons/")

#include <QAbstractItemModel>
#include <QModelIndex>
#include <QTreeView>
#include <cumacros.h>

class QAbstractItemModel;

class AlarmFilter
{
public:
    AlarmFilter(QTreeView *m) { m_v = m; changed = stat = false; }
    bool changed, stat;

    QString level, status;
    QStringList groups;

    void add(const QString& col, const QString& sub) {
        QAbstractItemModel *m = m_v->model();
        int c;
        for(c = 0; c < m->columnCount() && m->headerData(c, Qt::Horizontal).toString() != col; c++)
            ;
        fmap[c] = sub;
        changed = true;
    }

    void rem(const QString& col) {
        QAbstractItemModel *m = m_v->model();
        int c;
        for(c = 0; c < m->columnCount() && m->headerData(c, Qt::Horizontal).toString() != col; c++)
            ;
        printf("remming %s (%d) %s\n", qstoc(col), c, qstoc(fmap[c]));;
        fmap.remove(c);
        changed = true;
    }

    void filter(bool force = false);

    QMap<int, QString> fmap; // filter map
    QTreeView *m_v;
};

inline void AlarmFilter::filter(bool force) {
    if(changed || force) {
        changed = false;
        QAbstractItemModel *m = m_v->model();
        for(int i = 0; i < m->rowCount(); i++) {
            bool hide = false;
            foreach (int c, fmap.keys()) {
                hide |= !fmap[c].isEmpty() && !m->data(m->index(i, c), Qt::DisplayRole).toString().contains(fmap[c]);
            }
            m_v->setRowHidden(i, QModelIndex(), hide);
        }
    }
}


#endif


